bpf: add selftest for lirc_mode2 type program
authorSean Young <sean@mess.org>
Sun, 27 May 2018 11:24:10 +0000 (12:24 +0100)
committerDaniel Borkmann <daniel@iogearbox.net>
Wed, 30 May 2018 10:40:14 +0000 (12:40 +0200)
This is simple test over rc-loopback.

Acked-by: Yonghong Song <yhs@fb.com>
Signed-off-by: Sean Young <sean@mess.org>
Signed-off-by: Daniel Borkmann <daniel@iogearbox.net>
tools/bpf/bpftool/prog.c
tools/include/uapi/linux/bpf.h
tools/include/uapi/linux/lirc.h [new file with mode: 0644]
tools/lib/bpf/libbpf.c
tools/testing/selftests/bpf/.gitignore
tools/testing/selftests/bpf/Makefile
tools/testing/selftests/bpf/bpf_helpers.h
tools/testing/selftests/bpf/test_lirc_mode2.sh [new file with mode: 0755]
tools/testing/selftests/bpf/test_lirc_mode2_kern.c [new file with mode: 0644]
tools/testing/selftests/bpf/test_lirc_mode2_user.c [new file with mode: 0644]

index 39b88e76036797739e5a38fa6f99683e36ebbbd7..a4f435203feff52f9d7c9a04bf8d5c10c31d2c73 100644 (file)
@@ -71,6 +71,7 @@ static const char * const prog_type_name[] = {
        [BPF_PROG_TYPE_SK_MSG]          = "sk_msg",
        [BPF_PROG_TYPE_RAW_TRACEPOINT]  = "raw_tracepoint",
        [BPF_PROG_TYPE_CGROUP_SOCK_ADDR] = "cgroup_sock_addr",
+       [BPF_PROG_TYPE_LIRC_MODE2]      = "lirc_mode2",
 };
 
 static void print_boot_time(__u64 nsecs, char *buf, unsigned int size)
index 3f556b35ac8d3f5f443eebb64188713202bd9e1d..64ac0f7a689ef6422fbf0a6ba9a6519e98096338 100644 (file)
@@ -143,6 +143,7 @@ enum bpf_prog_type {
        BPF_PROG_TYPE_RAW_TRACEPOINT,
        BPF_PROG_TYPE_CGROUP_SOCK_ADDR,
        BPF_PROG_TYPE_LWT_SEG6LOCAL,
+       BPF_PROG_TYPE_LIRC_MODE2,
 };
 
 enum bpf_attach_type {
@@ -162,6 +163,7 @@ enum bpf_attach_type {
        BPF_CGROUP_INET6_POST_BIND,
        BPF_CGROUP_UDP4_SENDMSG,
        BPF_CGROUP_UDP6_SENDMSG,
+       BPF_LIRC_MODE2,
        __MAX_BPF_ATTACH_TYPE
 };
 
@@ -1852,10 +1854,10 @@ union bpf_attr {
  *             If lookup is successful and result shows packet is to be
  *             forwarded, the neighbor tables are searched for the nexthop.
  *             If successful (ie., FIB lookup shows forwarding and nexthop
- *             is resolved), the nexthop address is returned in ipv4_dst,
- *             ipv6_dst or mpls_out based on family, smac is set to mac
- *             address of egress device, dmac is set to nexthop mac address,
- *             rt_metric is set to metric from route.
+ *             is resolved), the nexthop address is returned in ipv4_dst
+ *             or ipv6_dst based on family, smac is set to mac address of
+ *             egress device, dmac is set to nexthop mac address, rt_metric
+ *             is set to metric from route (IPv4/IPv6 only).
  *
  *             *plen* argument is the size of the passed in struct.
  *             *flags* argument can be a combination of one or more of the
@@ -2005,6 +2007,53 @@ union bpf_attr {
  *             direct packet access.
  *     Return
  *             0 on success, or a negative error in case of failure.
+ *
+ * int bpf_rc_keydown(void *ctx, u32 protocol, u64 scancode, u32 toggle)
+ *     Description
+ *             This helper is used in programs implementing IR decoding, to
+ *             report a successfully decoded key press with *scancode*,
+ *             *toggle* value in the given *protocol*. The scancode will be
+ *             translated to a keycode using the rc keymap, and reported as
+ *             an input key down event. After a period a key up event is
+ *             generated. This period can be extended by calling either
+ *             **bpf_rc_keydown** () again with the same values, or calling
+ *             **bpf_rc_repeat** ().
+ *
+ *             Some protocols include a toggle bit, in case the button was
+ *             released and pressed again between consecutive scancodes.
+ *
+ *             The *ctx* should point to the lirc sample as passed into
+ *             the program.
+ *
+ *             The *protocol* is the decoded protocol number (see
+ *             **enum rc_proto** for some predefined values).
+ *
+ *             This helper is only available is the kernel was compiled with
+ *             the **CONFIG_BPF_LIRC_MODE2** configuration option set to
+ *             "**y**".
+ *
+ *     Return
+ *             0
+ *
+ * int bpf_rc_repeat(void *ctx)
+ *     Description
+ *             This helper is used in programs implementing IR decoding, to
+ *             report a successfully decoded repeat key message. This delays
+ *             the generation of a key up event for previously generated
+ *             key down event.
+ *
+ *             Some IR protocols like NEC have a special IR message for
+ *             repeating last button, for when a button is held down.
+ *
+ *             The *ctx* should point to the lirc sample as passed into
+ *             the program.
+ *
+ *             This helper is only available is the kernel was compiled with
+ *             the **CONFIG_BPF_LIRC_MODE2** configuration option set to
+ *             "**y**".
+ *
+ *     Return
+ *             0
  */
 #define __BPF_FUNC_MAPPER(FN)          \
        FN(unspec),                     \
@@ -2083,7 +2132,9 @@ union bpf_attr {
        FN(lwt_push_encap),             \
        FN(lwt_seg6_store_bytes),       \
        FN(lwt_seg6_adjust_srh),        \
-       FN(lwt_seg6_action),
+       FN(lwt_seg6_action),            \
+       FN(rc_repeat),                  \
+       FN(rc_keydown),
 
 /* integer value in 'imm' field of BPF_CALL instruction selects which helper
  * function eBPF program intends to call
@@ -2537,8 +2588,10 @@ struct bpf_raw_tracepoint_args {
 #define BPF_FIB_LOOKUP_OUTPUT  BIT(1)
 
 struct bpf_fib_lookup {
-       /* input */
-       __u8    family;   /* network family, AF_INET, AF_INET6, AF_MPLS */
+       /* input:  network family for lookup (AF_INET, AF_INET6)
+        * output: network family of egress nexthop
+        */
+       __u8    family;
 
        /* set if lookup is to consider L4 data - e.g., FIB rules */
        __u8    l4_protocol;
@@ -2554,22 +2607,20 @@ struct bpf_fib_lookup {
                __u8    tos;            /* AF_INET  */
                __be32  flowlabel;      /* AF_INET6 */
 
-               /* output: metric of fib result */
-               __u32 rt_metric;
+               /* output: metric of fib result (IPv4/IPv6 only) */
+               __u32   rt_metric;
        };
 
        union {
-               __be32          mpls_in;
                __be32          ipv4_src;
                __u32           ipv6_src[4];  /* in6_addr; network order */
        };
 
-       /* input to bpf_fib_lookup, *dst is destination address.
-        * output: bpf_fib_lookup sets to gateway address
+       /* input to bpf_fib_lookup, ipv{4,6}_dst is destination address in
+        * network header. output: bpf_fib_lookup sets to gateway address
+        * if FIB lookup returns gateway route
         */
        union {
-               /* return for MPLS lookups */
-               __be32          mpls_out[4];  /* support up to 4 labels */
                __be32          ipv4_dst;
                __u32           ipv6_dst[4];  /* in6_addr; network order */
        };
diff --git a/tools/include/uapi/linux/lirc.h b/tools/include/uapi/linux/lirc.h
new file mode 100644 (file)
index 0000000..f189931
--- /dev/null
@@ -0,0 +1,217 @@
+/* SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note */
+/*
+ * lirc.h - linux infrared remote control header file
+ * last modified 2010/07/13 by Jarod Wilson
+ */
+
+#ifndef _LINUX_LIRC_H
+#define _LINUX_LIRC_H
+
+#include <linux/types.h>
+#include <linux/ioctl.h>
+
+#define PULSE_BIT       0x01000000
+#define PULSE_MASK      0x00FFFFFF
+
+#define LIRC_MODE2_SPACE     0x00000000
+#define LIRC_MODE2_PULSE     0x01000000
+#define LIRC_MODE2_FREQUENCY 0x02000000
+#define LIRC_MODE2_TIMEOUT   0x03000000
+
+#define LIRC_VALUE_MASK      0x00FFFFFF
+#define LIRC_MODE2_MASK      0xFF000000
+
+#define LIRC_SPACE(val) (((val)&LIRC_VALUE_MASK) | LIRC_MODE2_SPACE)
+#define LIRC_PULSE(val) (((val)&LIRC_VALUE_MASK) | LIRC_MODE2_PULSE)
+#define LIRC_FREQUENCY(val) (((val)&LIRC_VALUE_MASK) | LIRC_MODE2_FREQUENCY)
+#define LIRC_TIMEOUT(val) (((val)&LIRC_VALUE_MASK) | LIRC_MODE2_TIMEOUT)
+
+#define LIRC_VALUE(val) ((val)&LIRC_VALUE_MASK)
+#define LIRC_MODE2(val) ((val)&LIRC_MODE2_MASK)
+
+#define LIRC_IS_SPACE(val) (LIRC_MODE2(val) == LIRC_MODE2_SPACE)
+#define LIRC_IS_PULSE(val) (LIRC_MODE2(val) == LIRC_MODE2_PULSE)
+#define LIRC_IS_FREQUENCY(val) (LIRC_MODE2(val) == LIRC_MODE2_FREQUENCY)
+#define LIRC_IS_TIMEOUT(val) (LIRC_MODE2(val) == LIRC_MODE2_TIMEOUT)
+
+/* used heavily by lirc userspace */
+#define lirc_t int
+
+/*** lirc compatible hardware features ***/
+
+#define LIRC_MODE2SEND(x) (x)
+#define LIRC_SEND2MODE(x) (x)
+#define LIRC_MODE2REC(x) ((x) << 16)
+#define LIRC_REC2MODE(x) ((x) >> 16)
+
+#define LIRC_MODE_RAW                  0x00000001
+#define LIRC_MODE_PULSE                0x00000002
+#define LIRC_MODE_MODE2                0x00000004
+#define LIRC_MODE_SCANCODE             0x00000008
+#define LIRC_MODE_LIRCCODE             0x00000010
+
+
+#define LIRC_CAN_SEND_RAW              LIRC_MODE2SEND(LIRC_MODE_RAW)
+#define LIRC_CAN_SEND_PULSE            LIRC_MODE2SEND(LIRC_MODE_PULSE)
+#define LIRC_CAN_SEND_MODE2            LIRC_MODE2SEND(LIRC_MODE_MODE2)
+#define LIRC_CAN_SEND_LIRCCODE         LIRC_MODE2SEND(LIRC_MODE_LIRCCODE)
+
+#define LIRC_CAN_SEND_MASK             0x0000003f
+
+#define LIRC_CAN_SET_SEND_CARRIER      0x00000100
+#define LIRC_CAN_SET_SEND_DUTY_CYCLE   0x00000200
+#define LIRC_CAN_SET_TRANSMITTER_MASK  0x00000400
+
+#define LIRC_CAN_REC_RAW               LIRC_MODE2REC(LIRC_MODE_RAW)
+#define LIRC_CAN_REC_PULSE             LIRC_MODE2REC(LIRC_MODE_PULSE)
+#define LIRC_CAN_REC_MODE2             LIRC_MODE2REC(LIRC_MODE_MODE2)
+#define LIRC_CAN_REC_SCANCODE          LIRC_MODE2REC(LIRC_MODE_SCANCODE)
+#define LIRC_CAN_REC_LIRCCODE          LIRC_MODE2REC(LIRC_MODE_LIRCCODE)
+
+#define LIRC_CAN_REC_MASK              LIRC_MODE2REC(LIRC_CAN_SEND_MASK)
+
+#define LIRC_CAN_SET_REC_CARRIER       (LIRC_CAN_SET_SEND_CARRIER << 16)
+#define LIRC_CAN_SET_REC_DUTY_CYCLE    (LIRC_CAN_SET_SEND_DUTY_CYCLE << 16)
+
+#define LIRC_CAN_SET_REC_DUTY_CYCLE_RANGE 0x40000000
+#define LIRC_CAN_SET_REC_CARRIER_RANGE    0x80000000
+#define LIRC_CAN_GET_REC_RESOLUTION       0x20000000
+#define LIRC_CAN_SET_REC_TIMEOUT          0x10000000
+#define LIRC_CAN_SET_REC_FILTER           0x08000000
+
+#define LIRC_CAN_MEASURE_CARRIER          0x02000000
+#define LIRC_CAN_USE_WIDEBAND_RECEIVER    0x04000000
+
+#define LIRC_CAN_SEND(x) ((x)&LIRC_CAN_SEND_MASK)
+#define LIRC_CAN_REC(x) ((x)&LIRC_CAN_REC_MASK)
+
+#define LIRC_CAN_NOTIFY_DECODE            0x01000000
+
+/*** IOCTL commands for lirc driver ***/
+
+#define LIRC_GET_FEATURES              _IOR('i', 0x00000000, __u32)
+
+#define LIRC_GET_SEND_MODE             _IOR('i', 0x00000001, __u32)
+#define LIRC_GET_REC_MODE              _IOR('i', 0x00000002, __u32)
+#define LIRC_GET_REC_RESOLUTION        _IOR('i', 0x00000007, __u32)
+
+#define LIRC_GET_MIN_TIMEOUT           _IOR('i', 0x00000008, __u32)
+#define LIRC_GET_MAX_TIMEOUT           _IOR('i', 0x00000009, __u32)
+
+/* code length in bits, currently only for LIRC_MODE_LIRCCODE */
+#define LIRC_GET_LENGTH                _IOR('i', 0x0000000f, __u32)
+
+#define LIRC_SET_SEND_MODE             _IOW('i', 0x00000011, __u32)
+#define LIRC_SET_REC_MODE              _IOW('i', 0x00000012, __u32)
+/* Note: these can reset the according pulse_width */
+#define LIRC_SET_SEND_CARRIER          _IOW('i', 0x00000013, __u32)
+#define LIRC_SET_REC_CARRIER           _IOW('i', 0x00000014, __u32)
+#define LIRC_SET_SEND_DUTY_CYCLE       _IOW('i', 0x00000015, __u32)
+#define LIRC_SET_TRANSMITTER_MASK      _IOW('i', 0x00000017, __u32)
+
+/*
+ * when a timeout != 0 is set the driver will send a
+ * LIRC_MODE2_TIMEOUT data packet, otherwise LIRC_MODE2_TIMEOUT is
+ * never sent, timeout is disabled by default
+ */
+#define LIRC_SET_REC_TIMEOUT           _IOW('i', 0x00000018, __u32)
+
+/* 1 enables, 0 disables timeout reports in MODE2 */
+#define LIRC_SET_REC_TIMEOUT_REPORTS   _IOW('i', 0x00000019, __u32)
+
+/*
+ * if enabled from the next key press on the driver will send
+ * LIRC_MODE2_FREQUENCY packets
+ */
+#define LIRC_SET_MEASURE_CARRIER_MODE  _IOW('i', 0x0000001d, __u32)
+
+/*
+ * to set a range use LIRC_SET_REC_CARRIER_RANGE with the
+ * lower bound first and later LIRC_SET_REC_CARRIER with the upper bound
+ */
+#define LIRC_SET_REC_CARRIER_RANGE     _IOW('i', 0x0000001f, __u32)
+
+#define LIRC_SET_WIDEBAND_RECEIVER     _IOW('i', 0x00000023, __u32)
+
+/*
+ * struct lirc_scancode - decoded scancode with protocol for use with
+ *     LIRC_MODE_SCANCODE
+ *
+ * @timestamp: Timestamp in nanoseconds using CLOCK_MONOTONIC when IR
+ *     was decoded.
+ * @flags: should be 0 for transmit. When receiving scancodes,
+ *     LIRC_SCANCODE_FLAG_TOGGLE or LIRC_SCANCODE_FLAG_REPEAT can be set
+ *     depending on the protocol
+ * @rc_proto: see enum rc_proto
+ * @keycode: the translated keycode. Set to 0 for transmit.
+ * @scancode: the scancode received or to be sent
+ */
+struct lirc_scancode {
+       __u64   timestamp;
+       __u16   flags;
+       __u16   rc_proto;
+       __u32   keycode;
+       __u64   scancode;
+};
+
+/* Set if the toggle bit of rc-5 or rc-6 is enabled */
+#define LIRC_SCANCODE_FLAG_TOGGLE      1
+/* Set if this is a nec or sanyo repeat */
+#define LIRC_SCANCODE_FLAG_REPEAT      2
+
+/**
+ * enum rc_proto - the Remote Controller protocol
+ *
+ * @RC_PROTO_UNKNOWN: Protocol not known
+ * @RC_PROTO_OTHER: Protocol known but proprietary
+ * @RC_PROTO_RC5: Philips RC5 protocol
+ * @RC_PROTO_RC5X_20: Philips RC5x 20 bit protocol
+ * @RC_PROTO_RC5_SZ: StreamZap variant of RC5
+ * @RC_PROTO_JVC: JVC protocol
+ * @RC_PROTO_SONY12: Sony 12 bit protocol
+ * @RC_PROTO_SONY15: Sony 15 bit protocol
+ * @RC_PROTO_SONY20: Sony 20 bit protocol
+ * @RC_PROTO_NEC: NEC protocol
+ * @RC_PROTO_NECX: Extended NEC protocol
+ * @RC_PROTO_NEC32: NEC 32 bit protocol
+ * @RC_PROTO_SANYO: Sanyo protocol
+ * @RC_PROTO_MCIR2_KBD: RC6-ish MCE keyboard
+ * @RC_PROTO_MCIR2_MSE: RC6-ish MCE mouse
+ * @RC_PROTO_RC6_0: Philips RC6-0-16 protocol
+ * @RC_PROTO_RC6_6A_20: Philips RC6-6A-20 protocol
+ * @RC_PROTO_RC6_6A_24: Philips RC6-6A-24 protocol
+ * @RC_PROTO_RC6_6A_32: Philips RC6-6A-32 protocol
+ * @RC_PROTO_RC6_MCE: MCE (Philips RC6-6A-32 subtype) protocol
+ * @RC_PROTO_SHARP: Sharp protocol
+ * @RC_PROTO_XMP: XMP protocol
+ * @RC_PROTO_CEC: CEC protocol
+ * @RC_PROTO_IMON: iMon Pad protocol
+ */
+enum rc_proto {
+       RC_PROTO_UNKNOWN        = 0,
+       RC_PROTO_OTHER          = 1,
+       RC_PROTO_RC5            = 2,
+       RC_PROTO_RC5X_20        = 3,
+       RC_PROTO_RC5_SZ         = 4,
+       RC_PROTO_JVC            = 5,
+       RC_PROTO_SONY12         = 6,
+       RC_PROTO_SONY15         = 7,
+       RC_PROTO_SONY20         = 8,
+       RC_PROTO_NEC            = 9,
+       RC_PROTO_NECX           = 10,
+       RC_PROTO_NEC32          = 11,
+       RC_PROTO_SANYO          = 12,
+       RC_PROTO_MCIR2_KBD      = 13,
+       RC_PROTO_MCIR2_MSE      = 14,
+       RC_PROTO_RC6_0          = 15,
+       RC_PROTO_RC6_6A_20      = 16,
+       RC_PROTO_RC6_6A_24      = 17,
+       RC_PROTO_RC6_6A_32      = 18,
+       RC_PROTO_RC6_MCE        = 19,
+       RC_PROTO_SHARP          = 20,
+       RC_PROTO_XMP            = 21,
+       RC_PROTO_CEC            = 22,
+       RC_PROTO_IMON           = 23,
+};
+
+#endif
index b1a60ac8424ea1cd0edd4214f589099f214a36e9..a1e96b5de5ff88c13926fdb28a70150f821ec694 100644 (file)
@@ -1462,6 +1462,7 @@ static bool bpf_prog_type__needs_kver(enum bpf_prog_type type)
        case BPF_PROG_TYPE_CGROUP_DEVICE:
        case BPF_PROG_TYPE_SK_MSG:
        case BPF_PROG_TYPE_CGROUP_SOCK_ADDR:
+       case BPF_PROG_TYPE_LIRC_MODE2:
                return false;
        case BPF_PROG_TYPE_UNSPEC:
        case BPF_PROG_TYPE_KPROBE:
index adc8e5474b66ccda0b0d656c044bf5adc19f724f..6ea83598246445e5ff24a5f01558b630ba08ea6a 100644 (file)
@@ -17,3 +17,4 @@ test_sock_addr
 urandom_read
 test_btf
 test_sockmap
+test_lirc_mode2_user
index a1b66da965d0f216fea2d5d472d65d026411efc9..553d1816b77a5c409f92eae945fc22c58c9fb74e 100644 (file)
@@ -24,7 +24,7 @@ urandom_read: urandom_read.c
 # Order correspond to 'make run_tests' order
 TEST_GEN_PROGS = test_verifier test_tag test_maps test_lru_map test_lpm_map test_progs \
        test_align test_verifier_log test_dev_cgroup test_tcpbpf_user \
-       test_sock test_btf test_sockmap
+       test_sock test_btf test_sockmap test_lirc_mode2_user
 
 TEST_GEN_FILES = test_pkt_access.o test_xdp.o test_l4lb.o test_tcp_estats.o test_obj_id.o \
        test_pkt_md_access.o test_xdp_redirect.o test_xdp_meta.o sockmap_parse_prog.o     \
@@ -34,7 +34,7 @@ TEST_GEN_FILES = test_pkt_access.o test_xdp.o test_l4lb.o test_tcp_estats.o test
        sockmap_tcp_msg_prog.o connect4_prog.o connect6_prog.o test_adjust_tail.o \
        test_btf_haskv.o test_btf_nokv.o test_sockmap_kern.o test_tunnel_kern.o \
        test_get_stack_rawtp.o test_sockmap_kern.o test_sockhash_kern.o \
-       test_lwt_seg6local.o sendmsg4_prog.o sendmsg6_prog.o
+       test_lwt_seg6local.o sendmsg4_prog.o sendmsg6_prog.o test_lirc_mode2_kern.o
 
 # Order correspond to 'make run_tests' order
 TEST_PROGS := test_kmod.sh \
@@ -44,7 +44,8 @@ TEST_PROGS := test_kmod.sh \
        test_offload.py \
        test_sock_addr.sh \
        test_tunnel.sh \
-       test_lwt_seg6local.sh
+       test_lwt_seg6local.sh \
+       test_lirc_mode2.sh
 
 # Compile but not part of 'make run_tests'
 TEST_GEN_PROGS_EXTENDED = test_libbpf_open test_sock_addr
index 334d3e8c5e891691cb48d96b4f8d224876a27b94..a66a9d91acf4c23e660188268877dc56918773d5 100644 (file)
@@ -126,6 +126,11 @@ static int (*bpf_lwt_seg6_action)(void *ctx, unsigned int action, void *param,
 static int (*bpf_lwt_seg6_adjust_srh)(void *ctx, unsigned int offset,
                                      unsigned int len) =
        (void *) BPF_FUNC_lwt_seg6_adjust_srh;
+static int (*bpf_rc_repeat)(void *ctx) =
+       (void *) BPF_FUNC_rc_repeat;
+static int (*bpf_rc_keydown)(void *ctx, unsigned int protocol,
+                            unsigned long long scancode, unsigned int toggle) =
+       (void *) BPF_FUNC_rc_keydown;
 
 /* llvm builtin functions that eBPF C program may use to
  * emit BPF_LD_ABS and BPF_LD_IND instructions
diff --git a/tools/testing/selftests/bpf/test_lirc_mode2.sh b/tools/testing/selftests/bpf/test_lirc_mode2.sh
new file mode 100755 (executable)
index 0000000..ce2e15e
--- /dev/null
@@ -0,0 +1,28 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+
+GREEN='\033[0;92m'
+RED='\033[0;31m'
+NC='\033[0m' # No Color
+
+modprobe rc-loopback
+
+for i in /sys/class/rc/rc*
+do
+       if grep -q DRV_NAME=rc-loopback $i/uevent
+       then
+               LIRCDEV=$(grep DEVNAME= $i/lirc*/uevent | sed sQDEVNAME=Q/dev/Q)
+       fi
+done
+
+if [ -n $LIRCDEV ];
+then
+       TYPE=lirc_mode2
+       ./test_lirc_mode2_user $LIRCDEV
+       ret=$?
+       if [ $ret -ne 0 ]; then
+               echo -e ${RED}"FAIL: $TYPE"${NC}
+       else
+               echo -e ${GREEN}"PASS: $TYPE"${NC}
+       fi
+fi
diff --git a/tools/testing/selftests/bpf/test_lirc_mode2_kern.c b/tools/testing/selftests/bpf/test_lirc_mode2_kern.c
new file mode 100644 (file)
index 0000000..ba26855
--- /dev/null
@@ -0,0 +1,23 @@
+// SPDX-License-Identifier: GPL-2.0
+// test ir decoder
+//
+// Copyright (C) 2018 Sean Young <sean@mess.org>
+
+#include <linux/bpf.h>
+#include <linux/lirc.h>
+#include "bpf_helpers.h"
+
+SEC("lirc_mode2")
+int bpf_decoder(unsigned int *sample)
+{
+       if (LIRC_IS_PULSE(*sample)) {
+               unsigned int duration = LIRC_VALUE(*sample);
+
+               if (duration & 0x10000)
+                       bpf_rc_keydown(sample, 0x40, duration & 0xffff, 0);
+       }
+
+       return 0;
+}
+
+char _license[] SEC("license") = "GPL";
diff --git a/tools/testing/selftests/bpf/test_lirc_mode2_user.c b/tools/testing/selftests/bpf/test_lirc_mode2_user.c
new file mode 100644 (file)
index 0000000..d470d63
--- /dev/null
@@ -0,0 +1,149 @@
+// SPDX-License-Identifier: GPL-2.0
+// test ir decoder
+//
+// Copyright (C) 2018 Sean Young <sean@mess.org>
+
+// A lirc chardev is a device representing a consumer IR (cir) device which
+// can receive infrared signals from remote control and/or transmit IR.
+//
+// IR is sent as a series of pulses and space somewhat like morse code. The
+// BPF program can decode this into scancodes so that rc-core can translate
+// this into input key codes using the rc keymap.
+//
+// This test works by sending IR over rc-loopback, so the IR is processed by
+// BPF and then decoded into scancodes. The lirc chardev must be the one
+// associated with rc-loopback, see the output of ir-keytable(1).
+//
+// The following CONFIG options must be enabled for the test to succeed:
+// CONFIG_RC_CORE=y
+// CONFIG_BPF_RAWIR_EVENT=y
+// CONFIG_RC_LOOPBACK=y
+
+// Steps:
+// 1. Open the /dev/lircN device for rc-loopback (given on command line)
+// 2. Attach bpf_lirc_mode2 program which decodes some IR.
+// 3. Send some IR to the same IR device; since it is loopback, this will
+//    end up in the bpf program
+// 4. bpf program should decode IR and report keycode
+// 5. We can read keycode from same /dev/lirc device
+
+#include <linux/bpf.h>
+#include <linux/lirc.h>
+#include <errno.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <poll.h>
+#include <sys/types.h>
+#include <sys/ioctl.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+
+#include "bpf_util.h"
+#include <bpf/bpf.h>
+#include <bpf/libbpf.h>
+
+int main(int argc, char **argv)
+{
+       struct bpf_object *obj;
+       int ret, lircfd, progfd, mode;
+       int testir = 0x1dead;
+       u32 prog_ids[10], prog_flags[10], prog_cnt;
+
+       if (argc != 2) {
+               printf("Usage: %s /dev/lircN\n", argv[0]);
+               return 2;
+       }
+
+       ret = bpf_prog_load("test_lirc_mode2_kern.o",
+                           BPF_PROG_TYPE_LIRC_MODE2, &obj, &progfd);
+       if (ret) {
+               printf("Failed to load bpf program\n");
+               return 1;
+       }
+
+       lircfd = open(argv[1], O_RDWR | O_NONBLOCK);
+       if (lircfd == -1) {
+               printf("failed to open lirc device %s: %m\n", argv[1]);
+               return 1;
+       }
+
+       /* Let's try detach it before it was ever attached */
+       ret = bpf_prog_detach2(progfd, lircfd, BPF_LIRC_MODE2);
+       if (ret != -1 || errno != ENOENT) {
+               printf("bpf_prog_detach2 not attached should fail: %m\n");
+               return 1;
+       }
+
+       mode = LIRC_MODE_SCANCODE;
+       if (ioctl(lircfd, LIRC_SET_REC_MODE, &mode)) {
+               printf("failed to set rec mode: %m\n");
+               return 1;
+       }
+
+       prog_cnt = 10;
+       ret = bpf_prog_query(lircfd, BPF_LIRC_MODE2, 0, prog_flags, prog_ids,
+                            &prog_cnt);
+       if (ret) {
+               printf("Failed to query bpf programs on lirc device: %m\n");
+               return 1;
+       }
+
+       if (prog_cnt != 0) {
+               printf("Expected nothing to be attached\n");
+               return 1;
+       }
+
+       ret = bpf_prog_attach(progfd, lircfd, BPF_LIRC_MODE2, 0);
+       if (ret) {
+               printf("Failed to attach bpf to lirc device: %m\n");
+               return 1;
+       }
+
+       /* Write raw IR */
+       ret = write(lircfd, &testir, sizeof(testir));
+       if (ret != sizeof(testir)) {
+               printf("Failed to send test IR message: %m\n");
+               return 1;
+       }
+
+       struct pollfd pfd = { .fd = lircfd, .events = POLLIN };
+       struct lirc_scancode lsc;
+
+       poll(&pfd, 1, 100);
+
+       /* Read decoded IR */
+       ret = read(lircfd, &lsc, sizeof(lsc));
+       if (ret != sizeof(lsc)) {
+               printf("Failed to read decoded IR: %m\n");
+               return 1;
+       }
+
+       if (lsc.scancode != 0xdead || lsc.rc_proto != 64) {
+               printf("Incorrect scancode decoded\n");
+               return 1;
+       }
+
+       prog_cnt = 10;
+       ret = bpf_prog_query(lircfd, BPF_LIRC_MODE2, 0, prog_flags, prog_ids,
+                            &prog_cnt);
+       if (ret) {
+               printf("Failed to query bpf programs on lirc device: %m\n");
+               return 1;
+       }
+
+       if (prog_cnt != 1) {
+               printf("Expected one program to be attached\n");
+               return 1;
+       }
+
+       /* Let's try detaching it now it is actually attached */
+       ret = bpf_prog_detach2(progfd, lircfd, BPF_LIRC_MODE2);
+       if (ret) {
+               printf("bpf_prog_detach2: returned %m\n");
+               return 1;
+       }
+
+       return 0;
+}